/*
    TITLE   readin.cpp
; ---------------------------------------------------------------------
;       *** Polhemus Incorporated ***
;
;       This document contains Proprietary information and except with
;       written permission of Polhemus Incorporated, such information
;       shall not be published, or disclosed to others, or used for any
;       purpose and the document shall not be copied in whole or in
;       part.
; ---------------------------------------------------------------------
;       ** Revision History **
;
;       15Jan95         SST
;       Initial
; ---------------------------------------------------------------------
*/

#include<conio.h>
#include<dos.h>
#include<stdio.h>
#include"trackio.h"

typedef struct ineuler_tag {
    int header;
    float x, y, z;
    float az, el, roll;
} PosOriEuler;

#define PORT 0x270

void main (void) {
    PosOriEuler po;
    int tempbuf[512];

    output_to_tracker(PORT, "\031", 1);  // Reset tracker.
    delay (200);
    // delay (1000);

    // output in the metric system
    output_to_tracker(PORT, "u", 1);
    // sensor 1 is there...
    output_to_tracker(PORT, "l1,1\n", 5);
    // sensor 2 isn't there
    output_to_tracker(PORT, "l2,0\n", 5);
    // we want x,y,z,az,el,roll
    output_to_tracker(PORT, "O1,52,54\n", 9);

    // capture_tracker returns number of 16 bit words read.
    while(0 != capture_tracker((unsigned int *)tempbuf, PORT));

    while (!kbhit()) {
        output_to_tracker(PORT, "P", 1);
        delay (100);
        // delay (1000);

        int numWords = capture_tracker((unsigned int *)&po, PORT);

        printf("%i words ", numWords);
        printf("Position: %5.2f, %5.2f, %5.2f   ", po.x, po.y, po.z);
        printf("Orientation: %5.2f, %5.2f, %5.2f\n", po.az, po.el, po.roll);
    }
}

